Bug Hunting Session
Bug 119228 - There is no way to flag/mark comments as resolved
Summary: There is no way to flag/mark comments as resolved
Status: VERIFIED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Writer (show other bugs)
Version:
(earliest affected)
Inherited From OOo
Hardware: All All
: medium enhancement
Assignee: Scott Clarke
URL:
Whiteboard: target:6.4.0
Keywords:
: 106126 (view as bug list)
Depends on:
Blocks: Writer-Comments DOC-Comments DOCX-Comments
  Show dependency treegraph
 
Reported: 2018-08-12 14:21 UTC by egor.katkov
Modified: 2019-08-26 08:19 UTC (History)
12 users (show)

See Also:
Crash report or crash signature:


Attachments
Screenshot of comment feature in Word 365 (99.95 KB, application/vnd.oasis.opendocument.text)
2019-06-20 18:11 UTC, Regina Henschel
Details
ODT file with resolved and unresolved comments (13.49 KB, application/vnd.oasis.opendocument.text)
2019-08-06 12:53 UTC, Scott Clarke
Details

Note You need to log in before you can comment on or make changes to this bug.
Description egor.katkov 2018-08-12 14:21:05 UTC
Description:
Hello!

In writer, it would be nice to go through a document and mark comments as resolved as they have been fixed instead of deleting them. The goal of this feature is to show that they were addressed when the text is sent back to the collaborators. This feature already exists in MS Word and it would be appropriate for them to be compatible.

Thank you, developers!



Steps to Reproduce:
1. Create .docx in MS Word with a comment marked as resolved
2. Open file in LibreOffice Writer

Actual Results:
The resolved comment appears unresolved.

Expected Results:
The resolved comment should be greyed out and take up minimal space.


Reproducible: Always


User Profile Reset: No



Additional Info:
Comment 1 Thomas Lendo 2018-08-21 20:29:55 UTC
https://wiki.openoffice.org/wiki/Notes2#Definition_of_Terms defined the Note Property Data which could contain a kind of task completion flag. Also https://wiki.openoffice.org/wiki/Notes2_OtherIdeas lists the idea of a simple  	Task Management within comments but it wasn't discussed.
Comment 2 Cor Nouws 2018-08-22 17:23:31 UTC
reasonable idea for me.
Of course, one can answer OK, DONE, etc currently.
Comment 3 Cor Nouws 2018-08-22 17:24:11 UTC
sorry, messed up the status - still unconfirmed
Comment 4 Heiko Tietze 2018-08-22 18:52:30 UTC
Seems we have some agreement on the idea. Crucial to me is the workflow, and I see it similar to go through changes. Hard to imagine that a user right clicks the comment (or this expander thingy) and flags it as resolved. Some ideas out of the blue:

Option 1: We add this to the Navigator. It would be link-like labels _Next, _Resolve, _Delete etc. (no idea how many links fit onto the UI). Alt+N/R/D jumps to the next comment.

Option 2: We introduce a comments toolbar similar to track changes.

Option 3: We include comments into TC and provide the flag feature at the sidebar (for some reason in experimental state).

Next question is what happen when the flag is set. I would show the comment in the Navigator (grayed out) in case of option 1 but jump over it in case of _Next. Similarly it could work for the TC sidebar (option 3).
At the document it makes sense to hide the comment outside the canvas but keep the word highlighted. On click the full text opens. It would be similar to Calc.


In any case, if a developer is interested the design team will happily support with another loop.

PS: Not to forget the reversal of making the comment unresolved.
Comment 5 Aron Budea 2018-10-22 18:22:39 UTC
*** Bug 106126 has been marked as a duplicate of this bug. ***
Comment 6 Jim MacArthur 2019-04-17 15:30:53 UTC
I would also like this feature. My employers see it as a blocker to moving to LibreOffice Online from Google Docs.

I don't have access to MS Word so I can't see how that handles resolved comments, but we are currently basing the workflow on Google Docs, which means:

1) Comments start out as unresolved
2) Resolved/unresolved is a property of a comment thread rather than individual comments
3) Resolved comments are usually invisible but can be made visible and marked as unresolved.

Personally I would add a 'resolve/unresolve' button to the context menu for comments, and have an extra option on the View menu called 'Show resolved comments'; by default this would be off and resolved comments would be hidden.

We're willing to undertake this work, but I'd like to get a consensus on how it should work before doing too much.
Comment 7 Heiko Tietze 2019-04-18 08:10:59 UTC
(In reply to Jim MacArthur from comment #6)
>... 
> We're willing to undertake this work, but I'd like to get a consensus on how
> it should work before doing too much.

That's great and I like what you plan to implement. But one piece is missing: Where/how to store the flag with the document. If it's part of the ODF standard everything is fine. If not... Regina, your wisdom is required.
Comment 8 Jim MacArthur 2019-06-13 16:53:38 UTC
(In reply to Heiko Tietze from comment #7)
> (In reply to Jim MacArthur from comment #6)

> That's great and I like what you plan to implement. But one piece is
> missing: Where/how to store the flag with the document. If it's part of the
> ODF standard everything is fine. If not... Regina, your wisdom is required.

There's nothing that exactly matches in ODF 1.2. There is the 'office:display' boolean flag which I don't believe LibreOffice uses for anything. Would it be a misuse if we used that for our 'resolved' flag?
Comment 9 Heiko Tietze 2019-06-18 13:04:29 UTC
(In reply to Jim MacArthur from comment #8)
> There's nothing that exactly matches in ODF 1.2. There is the
> 'office:display' boolean flag which I don't believe LibreOffice uses for
> anything. Would it be a misuse if we used that for our 'resolved' flag?

Regina, what do you think?
Comment 10 Regina Henschel 2019-06-20 17:26:59 UTC
office:display is used for annotations in Calc. You cannot use it for a "resolved" flag.
Comment 11 Regina Henschel 2019-06-20 18:11:36 UTC
Created attachment 152317 [details]
Screenshot of comment feature in Word 365

I have made some screenshots, which show the comment feature of Word 365.
Comment 12 Scott Clarke 2019-07-11 13:23:00 UTC
I've done some work on this issue using the patches submitted by Jim MacArthur a few weeks ago as a starting point. I've made changes according to the comments left on the patches.

From what I read a key issue was the use of XML_NAMESPACE_DC when XML_NAMESPACE_LO_EXT must be used (mentioned in the comments here https://gerrit.libreoffice.org/#/c/74451/1).

As I understand from the libreoffice docs, when extending ODF in this way using the LO_EXT namespace, it's necessary to have a suggested namespace for the added tag (see https://wiki.documentfoundation.org/Development/ODF_Implementer_Notes#LibreOffice_ODF_extensions).

Based on this I have modified the code so that the added flag is part of the LO_EXT namespace, whilst allowing for it to potentially become part of the DC namespace in future. I'm not sure if this is the right approach, specifically in terms of the choice of DC as the suggested namespace. Any advice on the best way of doing this would be greatly appreciated.
Comment 13 Commit Notification 2019-07-25 08:39:36 UTC
Scott Clarke committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/+/d2025bdc33cc8d9e2f6c9f90da4574275ed6b0e4%5E%21

tdf#119228 Add storage and serialisation for the Resolved flag

It will be available in 6.4.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 14 Commit Notification 2019-08-06 05:29:04 UTC
Scott Clarke committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/+/f4f5e3f98aee5d9d1679edab8248a4cfd12f74ce%5E%21

tdf#119228 Add accessors for resolved state

It will be available in 6.4.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 15 Scott Clarke 2019-08-06 12:53:39 UTC
Created attachment 153173 [details]
ODT file with resolved and unresolved comments

An example ODT file containing resolved and unresolved comments as requested here: https://gerrit.libreoffice.org/#/c/75860/15
Comment 16 Commit Notification 2019-08-07 07:44:05 UTC
Scott Clarke committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/+/7ade0c7d03594bfa5c067f32230a1e4ed93d7fbb%5E%21

tdf#119228 Add UI elements to display the resolved state

It will be available in 6.4.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 17 Commit Notification 2019-08-07 07:45:27 UTC
Scott Clarke committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/+/6986ebd4a0020e515a115acbe7f1f738a4fd83f4%5E%21

tdf#119228 Add UI elements to resolve and unresolve comments

It will be available in 6.4.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 18 Commit Notification 2019-08-08 06:06:29 UTC
Scott Clarke committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/+/fb3a0b084701ee1089a76568b3b110ac5b0df460%5E%21

tdf#119228 Add 'Resolved Comments' option to the View menu.

It will be available in 6.4.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 19 Samuel Mehrbrodt (CIB) 2019-08-08 06:07:40 UTC
Looks fixed now :)
Please file any other problems as separate bugs.
Comment 20 Dieter Praas 2019-08-26 08:19:57 UTC
Verified with

Version: 6.4.0.0.alpha0+ (x64)
Build ID: 3e64065612acec2eb29aa21e2b515953422256d7
CPU threads: 4; OS: Windows 10.0; UI render: GL; VCL: win; 
TinderBox: Win-x86_64@62-TDF, Branch:master, Time: 2019-08-15_22:57:26
Locale: de-DE (de_DE); UI-Language: en-US
Calc: threaded

Scott, thanks for implementing this feature.